import * as React from "react";
import useRenderElement from "./useRenderElement.js";
export var ComponentRender = function ComponentRender(props) {
  var fallbackElement = props.fallbackElement,
      runtimeError = props.runtimeError,
      onRender = props.onRender;

  var _useRenderElement = useRenderElement(props),
      element = _useRenderElement.element,
      compilerError = _useRenderElement.error;

  var error = runtimeError || compilerError;
  React.useEffect(function () {
    if (!error) {
      fallbackElement.current = React.cloneElement(element);
    }

    if (onRender) {
      onRender(error);
    }
  });
  return error ? fallbackElement.current : element;
};