// @ts-ignore There are no types for "@babel/standalone" :(
import * as Babel from "@babel/standalone";
import merge from "deepmerge";
import * as React from "react";
import isEqual from "react-fast-compare";
import { exportToIifePlugin } from "./export-to-iife-plugin.js";
import { importResolverPlugin } from "./import-resolver-plugin.js";

var registerBabelPlugin = function registerBabelPlugin(pluginName, pluginFunction) {
  if (!Babel.availablePlugins[pluginName]) {
    Babel.registerPlugin(pluginName, pluginFunction);
  }
};

registerBabelPlugin("export-to-iife", exportToIifePlugin);
registerBabelPlugin("import-resolver", importResolverPlugin);
export var useBabelConfig = function useBabelConfig(config) {
  var latestConfig = React.useRef();
  var mergedConfig = React.useRef({});

  if (!isEqual(latestConfig.current, config)) {
    latestConfig.current = config;
    mergedConfig.current = merge({
      plugins: ["import-resolver", "export-to-iife"],
      presets: ["react"]
    }, config);
  }

  return mergedConfig.current;
};
export var useBabelTransform = function useBabelTransform(config, source) {
  try {
    var mergedConfig = useBabelConfig(config);
    var transformed = React.useMemo(function () {
      return Babel.transform(source, mergedConfig).code;
    }, [source, mergedConfig]);
    return {
      error: null,
      transformed: transformed
    };
  } catch (error) {
    return {
      error: error,
      transformed: ""
    };
  }
};