import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import * as React from "react";
import { useCreateComponentFromSource } from "./useCreateComponentFromSource.js";

var useRenderElement = function useRenderElement(options) {
  var babelConfig = options.babelConfig,
      source = options.source,
      resolver = options.resolver,
      unstable_hot = options.unstable_hot,
      rest = _objectWithoutProperties(options, ["babelConfig", "source", "resolver", "unstable_hot"]);

  var latestElement = React.useRef(null);

  try {
    var component = useCreateComponentFromSource(babelConfig, unstable_hot, source, resolver);
    latestElement.current = React.createElement(component, rest);
    return {
      element: latestElement.current,
      error: null
    };
  } catch (error) {
    return {
      element: latestElement.current,
      error: error
    };
  }
};

export default useRenderElement;