import * as PropTypes from "prop-types";
import * as React from "react";
import { RenderConfig, SourceCode } from "./types";
declare type SourceRenderProps = RenderConfig & {
    onRender?: (error: Error | null) => void;
};
declare type SourceRenderState = {
    error: Error | null;
    source: SourceCode;
};
export declare class SourceRender extends React.PureComponent<SourceRenderProps, SourceRenderState> {
    static propTypes: {
        babelConfig: PropTypes.Requireable<object>;
        onError: PropTypes.Requireable<(...args: any[]) => any>;
        resolver: PropTypes.Validator<(...args: any[]) => any>;
        resolverContext: PropTypes.Requireable<object>;
        source: PropTypes.Validator<string>;
        unstable_hot: PropTypes.Requireable<boolean>;
    };
    static defaultProps: {
        babelConfig: {};
        renderHtml: boolean;
        resolverContext: {};
        unstable_hot: boolean;
    };
    fallbackElement: React.MutableRefObject<React.ReactElement<any, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>>;
    state: {
        error: null;
        source: string;
    };
    static getDerivedStateFromProps(props: SourceRenderProps, state: SourceRenderState): SourceRenderState;
    static getDerivedStateFromError(error: Error): Partial<SourceRenderState>;
    handleResolve: (importName: string) => void;
    render(): JSX.Element;
}
export {};
